﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using System.ComponentModel;

namespace SplineSample
{
    public class ChartSample : ContentPage
    {
        ObservableCollection<ChartDataPoint> DataPoints;
        DateTimeAxis xAxis;
        double zoomRatio;
        DateTime firstDay;
        DateTime lastDay;
        DateTime rangeStartDate;

        public ChartSample()
        {
            SfChart chart = new SfChart();

            DataPoints = new ObservableCollection<ChartDataPoint>();

            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 3, 0, 0, 0), 20));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 3, 6, 0, 0), 15));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 3, 12, 0, 0), 18));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 3, 18, 0, 0), 20));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 3, 23, 59, 59), 20));

            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 4, 0, 0, 0), 20));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 4, 6, 0, 0), 15));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 4, 12, 0, 0), 18));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 4, 18, 0, 0), 20));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 4, 23, 59, 59), 20));

            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 5, 0, 0, 0), 20));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 5, 6, 0, 0), 15));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 5, 12, 0, 0), 18));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 5, 18, 0, 0), 20));
            DataPoints.Add(new ChartDataPoint(new DateTime(2017, 1, 5, 23, 59, 59), 20));

            xAxis = new DateTimeAxis();
            xAxis.LabelStyle.LabelFormat = "dd MMM hh:mm";

            firstDay = new DateTime(2017, 1, 3, 0, 0, 0);
            lastDay = new DateTime(2017, 1, 5, 23, 59, 59);
            rangeStartDate = new DateTime(2017, 1, 4, 0, 0, 0);

            var totalDays = (lastDay - firstDay).TotalDays;
            var rangeStartDays = (rangeStartDate - firstDay).TotalDays;

            zoomRatio = Math.Round(rangeStartDays / totalDays, 2, MidpointRounding.AwayFromZero);

            xAxis.ZoomFactor = zoomRatio;
            xAxis.ZoomPosition = zoomRatio;
            chart.PrimaryAxis = xAxis;

            NumericalAxis yAxis = new NumericalAxis();
            chart.SecondaryAxis = yAxis;

            SplineSeries series = new SplineSeries();
            series.ItemsSource = DataPoints;
            chart.Series.Add(series);

            chart.ChartBehaviors.Add(new ChartZoomPanBehavior()
            {
                EnableDoubleTap = false
            });

            Content = chart;
        }
    }
}

